[CmdletBinding()]
param (
  [Parameter(Mandatory = $false)]
  [string]
  $debugMode = "N",
  [Parameter(Mandatory = $false)]
  [string]
  $elevate = "N"
)


# -----
# - check paramter values
# ---

if ($debugMode -ne "Y" -and $debugMode -ne "N") { exit }
if ($elevate -ne "Y" -and $elevate -ne "N") { exit }


# -----
# - elevate script if required
# ---

if ($elevate -ne "Y" -and -not ([Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator")) {

  $ps1 = "'" + $myinvocation.mycommand.definition + "'"
  Write-Host "ps1 = $ps1"

  $windowStyle = switch ($debugMode) { "Y" { "Normal" }  "N" { "Hidden" } }
  Write-Host "windowstyle = $windowStyle"
  
  Start-Process -FilePath "powershell.exe" -Verb RunAs -WindowStyle $windowStyle -ArgumentList @("-NoProfile", "-ExecutionPolicy Bypass", "-Command & {&$ps1 -debugMode $debugMode -elevate Y}")
  
  if ($debugMode -eq "Y") {
    Write-Host ""
    Read-Host "Paused, press 'enter' to exit"
  }
  
  exit

}


# -----
# - work through possible power bi desktop locations
# ---

$pbiDesktopFullName = 'C:\Program Files\Microsoft Power BI Desktop\bin\PBIDesktop.exe'
$pbiDesktopFullNameAlt = 'C:\Program Files (x86)\Microsoft Power BI Desktop\bin\PBIDesktop.exe'
$pbiDesktop = $null

if (Test-Path $pbiDesktopFullName -PathType leaf) {
  $pbiDesktop = $pbiDesktopFullName
}
elseif (Test-Path $pbiDesktopFullNameAlt -PathType leaf) {
  $pbiDesktop = $pbiDesktopFullNameAlt
}
else {
  $pbiDesktop = 'PBIDesktopStore.exe'
}

Write-Host "pbiDesktop = $pbiDesktop"


# -----
# - identify where pbix file is
# ---

$pbixFileFullName = 'C:\Program Files (x86)\Common Files\Microsoft Shared\Power BI Desktop\External Tools\Practice Dataset\Practice Dataset.pbix'
$pbixFileFullNameAlt = 'C:\Program Files\Common Files\Microsoft Shared\Power BI Desktop\External Tools\Practice Dataset\Practice Dataset.pbix'
$pbixFile = $null

if (Test-Path ($pbixFileFullName) -PathType leaf) {
  $pbixFile = '"' + $pbixFileFullName + '"'
}
elseif (Test-Path ($pbixFileFullNameAlt) -PathType leaf) {
  $pbixFile = '"' + $pbixFileFullNameAlt + '"'
}

Write-Host "pbixFile = $pbixFile"


# -----
# - start power bi desktop if arguments are valid
# ---

if ($pbiDesktop -And $pbixFile) {
  Start-Process -FilePath $pbiDesktop -ArgumentList @($pbixFile)
}

if ($debugMode -eq "Y") {
  Write-Host ""
  Read-Host "Paused, press 'enter' to exit"
}